//	Potome -- photo-measure
//	Copyright (C) 2010 Hepota (http://tamagaro.net/)
//	
//	This program is free software; you can redistribute it and/or
//	modify it under the terms of the GNU General Public License
//	as published by the Free Software Foundation; either version 2
//	of the License, or (at your option) any later version.
//	
//	This program is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
//	GNU General Public License for more details.
//	
//	You should have received a copy of the GNU General Public License
//	along with this program; if not, write to the Free Software
//	Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//

var poto = {};

// potolib.js
(function(){

poto.version = '0.42';

var ua = poto.ua = {};
var conf = poto.conf = {};
var dom = poto.dom = {};
var cons = poto.cons = {};
var event = poto.event = {};
var lib = poto.lib = {};

// ua
(function(){
	var agt = navigator.userAgent.toLowerCase();
	var a, ver;
	ua.msie = false;
	if ( (a = agt.match(/msie ([\d\.]*);/)) ) {
		ver = a[1];
		ua.msie = ver;
	}
	ua.opera = agt.indexOf("opera") != -1;
	ua.safari = agt.indexOf("safari") != -1;
	ua.firefox = agt.indexOf("firefox") != -1;

	ua.unsupport = ua.msie && ua.msie < 6;

})();

// debug console
// デバッグ用。
(function(){
	var ta;
	var buf = '';
	var n = 0;
	var m = 100;	// 行数
	var stat = 0;

	// textareaは、リサイズ時に親要素と同じ大きさに設定するようにした。
	cons.create = function(){
		ta = dom.textarea({
				warp:'soft',
				style:{
					position:'absolute',
					left:0, top:0, width:'100%', height:'100%',
					margin:0, overflow:'scroll',
					border:'inset 2px #CCC',
					fontSize:'1em', lineHeight:'1em'
				}}
		);
		cons.obj = ta;
		n = 0;
		buf = '';
		stat = 0;
		return ta;
	}

	// out
	cons.out = function(text){
		var pos;
		if ( n >= m ) {
			pos = buf.indexOf('\n');
			if ( pos >= 0 ) {
				buf = buf.substr(pos+1);
			}
		} else {
			n++;
		}
		buf = buf + text+'\n';
		if ( ta ) {
			ta.value = buf;
			ta.scrollTop = ta.scrollHeight;
		}
	};

	cons.debug = function(args){
		cons.out( 'debug: ' + lib.join(arguments,''));
	};

	cons.info = function(args){
		cons.out( 'info: ' + lib.join(arguments,''));
	};

	cons.warn = function(args){
		cons.out( 'warn: ' + lib.join(arguments,''));
	};

	cons.error = function(args){
		cons.out( 'err: ' + lib.join(arguments,''));
	};

// 未使用。
// 表に表示しないと、
// 継続不可能な場合、今はない。
	cons.fatal = function(args){
		cons.out( 'fatal: ' + lib.join(arguments,''));
		cons.show();
	};

// デバッグ
	cons.dump = function(obj){
		var i, k;
		i = 0;
		for(k in obj){
			i++;
			if ( i > 100 ) {
				break;
			}
			cons.deubg(k,': ',obj[k]);
		}
	}

})();


// event
(function(){
	// ネットにあったのをコピーしてきた。
	// どこからコピーしたか覚えてない。

	// えらーとかコンソールに出した方がいい。
	event.addEvent = function(element, eventType, fn) {
		if (element.addEventListener) {
			element.addEventListener(eventType, fn, false);
		} else if (element.attachEvent) {
			element.attachEvent('on' + eventType, fn);
		} else {
			// 古いブラウザ、たぶん動かない。
			element['on'+eventType] = fn;
		}    
	}

	function getPosX (elm) {
		var posX = 0;
		if ( typeof elm.offsetParent != 'undefined' ) {
			do {
				posX += elm.offsetLeft;
			} while ((elm = elm.offsetParent));
		}
		else if ( typeof elm.x != 'undefined' ) {
			posX += elm.x;
		}
		return posX;
	}

	function getPosY (elm) {
		var posY = 0;
		if ( typeof elm.offsetParent != 'undefined' ) {
			do {
				posY += elm.offsetTop;
			} while ((elm = elm.offsetParent));
		}
		else if ( typeof obj.y != 'undefined' ) {
			posY += elm.y;
		}
		return posY;
	}

	// 
	event.dontprop = function(e){
		if ( e ) {
			if ( e.preventDefault ) e.preventDefault();
			if ( e.stopPropagation ) e.stopPropagation(); 
		}
		if ( (e = window.event) ) {
			e.returnValue = false; 
			e.cancelBubble = true; 
		}
	}

	// マウス座標をt要素相対にする
	event.translate = function(ev,t){
		var e = window.event? window.event: ev;
		var x0 = 0, y0 = 0;
		if ( typeof e.pageX != 'undefined' && typeof e.pageY != 'undefined' ) {
			x0 = e.pageX;
			y0 = e.pageY;
		} else if ( typeof e.clientX != 'undefined'
				&& typeof e.clientY != 'undefined' ) {
			x0 = e.clientX;
			y0 = e.clientY;
			if ( ua.msie ) {
				x0 += document.documentElement.scrollLeft;
				y0 += document.documentElement.scrollTop;
			}
		}
		var x = x0 - getPosX(t);
		var y = y0 - getPosY(t);
		return { x:x, y:y };
	}

})();


// lib うぞうむぞう
(function (){

	lib.clip = function(val,min,max){
		if ( val < min ) val = min;
		if ( val > max ) val = max;
		return val;
	}

	lib.css_color = function(r0,g0,b0,a0){
		var r,g,b,a;
		r = lib.clip(Math.floor(r0*255+0.5),0,255);
		g = lib.clip(Math.floor(g0*255+0.5),0,255);
		b = lib.clip(Math.floor(b0*255+0.5),0,255);
		a = lib.clip(a0,0,1);
		if ( a < 1 ) {
			return 'rgba(' + r + ',' + g + ',' + b + ',' + a + ')';
		} else {
			return 'rgb('+r+','+g+','+b+')';
		}
	}
	// 両方ゼロだとエラーになるかもしれん。
	// 引数の順序は y, x だよ。ネットで見た情報を信じたら、えらいハマった。
	lib.atan2 = function(y,x){
		if( y == 0 && x == 0 ) {
			return Math.PI;
		} else {
			return Math.atan2(y,x);
		}
	}

	// 距離
	lib.hypot = function(x,y){
		return Math.sqrt(x*x+y*y);
	}

	// argumentsがようわからん。
	lib.join = function (a,d){
		var i, s;
		if ( a.length == null ) {
			s = a;
		} else {
			s = '';
			if ( !d ) {
				d = '';
			}
			for(i = 0; i < a.length; i++){
				if ( s ) {
					s += d;
				}
				s += a[i];
			}
		}
		return s;
	}

	// 
	lib.map = function(func,array){
		var i, A;
		A = [];
		for( i = 0; i < array.length; i++ ) {
			A.push(func(array[i]));
		}
		return A;
	}

	// repeat?
	// 文字列の場合とか
	// map と range
	// list.map
	// list.for
	lib.repeat = function(func,n){
		var i, A;
		A = [];
		for( i = 0; i < n; i++ ) {
			A.push(func(i));
		}
		return A;
	};

	lib.count = function(a){
		var i, count;
		for( i = 0, count = 0; i < a.length; i++ ) {
			if ( a[i] != null ) {
				count++;
			}
		}
		return count;
	};

	// JavaScriptには、sprintf相当の機能がないらしい。
	// ネットを検索してみたが、まともそうなのが、上位に出てこなくて、
	// とりあえず、固定小数点表示用の、とても雑なものを作っておいた。
	// nは小数点以下の桁数。
	lib.prtf = function(v,n){
		var ip, fp, d, m, is, fs, i;
		if ( n == null || n < 0 ) { n = 0; }
		// あんまり大きいのは無理っぽい。
		if ( n > 9 ) { n = 9; }
		if ( n == 0 ) {
			return Math.floor(v+1/2).toString();
		}
		ip = Math.floor(v);
		fp = v - ip;
		d = Math.floor(Math.pow(10,n)+0.5);
		fp = Math.floor(fp*d+1/2);
		if ( fp >= d ) {
			fp -= d;
			ip++;
		}
		is = ip.toString();
		if ( is.match(/[a-z]/i) ) {
			return is;
		}
		fs = fp.toString();
		for( i = fs.length; i < n; i++ ) {
			fs = '0' + fs;
		}
		return is + '.' + fs;
	}; // ;が無いとダメな場合がある…

	/* cookie
		まとめる
		key1=val1|key2=val2|...
	*/
	(function(){
		lib.cookie = {};

		// data = {}
		lib.cookie.load = function(name){
			var a, b, c, i, re, data;
			data = {};
			re = RegExp(";\\s*"+name+"\\s*=([^;]*)");
			a = (';'+document.cookie).match(re);
			if ( a ) {
				b = a[1].split(/\|/);
				for( i = 0; i < b.length; i++ ) {
					c = b[i].match(/^([^=]*)=(.*)$/);
					if ( c ) {
						data[c[1]] = unescape(c[2]);
					}
				}
			}
			return data;
		}

		// data = { key:string, ... }
		lib.cookie.save = function(name,data,path){
			var str, key;
			str = '';
			if ( !path ) path = '/';
			for(key in data){
				if ( data[key] != null ) {
					str += key + '=' + escape(data[key]) + '|';
				}
			}
			var date = new Date();
			date.setDate(date.getDate()+365);
			document.cookie = name+'='+str+';'
				+'path='+path+';'
				+'expires='+date.toGMTString()+';';
		}

	})();

	lib.encode_uri = function(s){
		return encodeURIComponent(s);
	};

	lib.decode_uri = function(s){
			return decodeURIComponent(s);
	}

	// queryストリングのパラメタを取り出す。
	lib.get_query_info = function(){
		var r = {};
		var s, a, i, e, b, key, val;
		s = location.search;
		// ?だけ？
		if ( !s.match(/^\?/) ) {
			return r;
		}
		s = s.substr(1);
		a = s.split(/&/);
		for( i = 0; i < a.length; i++ ) {
			e = a[i];
			if ( !(b = e.match(/^\s*([a-z_][a-z_0-9]*)\s*=(.*)$/i)) ) {
				continue;
			}
			key = b[1];
			val = lib.decode_uri(b[2].replace(/^\s*/,'').replace(/s*$/,''));
			r[key] = val;
		}
		return r;
	};

})();

(function(){
	// dom
	//
	// 画面を絶対的な大きさ(2emとか)と残りの部分に分けたいとき、
	//	(例えば、タイトルバーとかツールバーのようなものを出したいとき)
	// IE以外は次のように書けるが、
	// 		top:'2em'; bottom:0;
	// IEはどうしてもだめなので、JavaScriptで処理することにした。
	// いろいろと制限が多いので、画面全体構成でのみ使う。
	// 
	// あと、textarea, input(text)の問題も吸収?
	// canvasのサイズ?
	//

	// appendText
	function appendText(el,text){
		var t = document.createTextNode(text);
		el.appendChild(t);
	}

	//
	function setAttr(el,attr){
		var k, v, s, A;
		for( k in attr ) {
			v = attr[k];
			if ( k == 'style' ) {
				for(s in v) {
					if ( ua.msie < 8
							&& v.position == 'absolute'
							&& (((s == 'top' || s == 'bottom')
									&& v.top != null && v.bottom != null)
								||((s == 'left' || s == 'right')
									&& v.left != null && v.right != null)
							)) {
						set_geom(el,s,v[s]);
					} else {
						el.style[s] = v[s];
					}
				}
			} else if ( (A = k.match(/^on(.*)$/)) ) {
				// onchangeとか。
				event.addEvent(el, A[1], v );
			} else if ( v != null ) {
				// setAttributeじゃないとだめな場合と、
				// 直接入れないとだめな場合がある?
				// よくわからんぞ。
				if ( k == 'for' ) {
					el.setAttribute(k,v);
				} else {
					el[k] = v;
				}
			}
		}
	}

	//
	function appendElements(el,args){
		var j, a;
		for( j = 0; j < args.length; j++ ) {
			a = args[j];
			if ( a == null ) continue;
			switch(typeof(a)) {
			case 'string':
			case 'number':
			case 'boolean':
				appendText(el,a);
				break;
			case 'undefined':
				appendText(el,'(undefined)');
				break;
			case 'object':
				if ( a.nodeType ) {
					// たぶんDOMオブジェクト
					el.appendChild(a);
				} else if ( a.length ) {
					// 配列。[]でまとめて渡せる。
					appendElements(el,a);
				}
				break;
			default:
				appendText(el,'error');
				break;
			}
		}
	}

	//
	function merge_attr(args){
		function merge_style(attr,style){
			var s, k;
			if ( !(s = attr.style) ) { attr.style = s = {}; }
			for(k in style){
				s[k] = style[k];
			}
		}
		var i, a, k, attr;
		attr = {};
		for( i = 0; i < args.length; i++ ) {
			a = args[i];
			if ( !a || typeof(a) != 'object' || a.nodeType ) {
				continue;
			}
			for( k in a ) {
				v = a[k];
				if ( k == 'style' ) {
					merge_style(attr,v);
				} else {
					attr[k] = v;
				}
			}
		}
		return attr;
	}

	// なんじゃそりゃー！
	// http://cf-bill.blogspot.com/2006/03/another-ie-gotcha-dynamiclly-created.html
	var CRAZY_IE = {
		input: function(){
			var attr = merge_attr(arguments);
			var t, el;
			// radioだけ？
			if ( attr.type == 'radio' ) {
				t = "<input type='radio' name='" + attr.name + "'";
				if ( attr.id ) {
					t += " id='" + attr.id + "'";
				}
				t += " />";
				el = document.createElement(t);
			} else {
				el = document.createElement('input');
			}
			// 2重に設定しても大丈夫？
			setAttr(el,attr);
			appendElements(el,arguments);
			return el;
		},

		label: function(arg){
			var attr = merge_attr(arguments);
			var t, el;
			t = "<label ";
			if ( attr['for'] ) {
				t += " for='" + attr['for'] + "'";
			}
			t += " />";
			el = document.createElement(t);
// 全部やっても大丈夫じゃないか？
// 
			setAttr(el,attr);
			appendElements(el,arguments);
			return el;
		}
	};

	//
	function set_geom(el,name,val){
		var geom, dummy;
		if ( !el._poto_geom ) { el._poto_geom = {} }
		geom = el._poto_geom;
		geom[name] = val;

		// 1emのピクセル値を取り出す方法がわからない。
		if ( !geom.div_em ) {
			geom.div_em = 
			dummy = document.createElement('div');
			dummy.style.position = 'absolute';
			dummy.style.visibility = 'hidden';
			dummy.style.top = '0';
			dummy.style.bottom = '0';
			dummy.style.width = '1em';
			dummy.style.height = '1em';
			el.appendChild(dummy);
		}
	}

	// onresize
	function resize_elem(el,width,height){
		var em, geom, width2, height2, e;
		geom = el._poto_geom;
		if ( !geom ) { return; }
		if ( !width ) { width = 0; }
		if ( !height ) { height = 0; }
		em = geom.div_em.clientWidth;
		function ev(offset){
			var w, val, unit, a;
			if ( offset == null ) {
//				cons.error('offset: ',offset);
				val = 0; unit = 'px';
			} else if ( offset.match && (a = offset.match(
					/^\s*([\d\.\+\-]+)\s*([^\d\.\+\-\s].*)$/)) ) {
				val = a[1];
				unit = a[2].replace(/\s*$/,'').toLowerCase();
			} else {
				val = offset;
				unit = 'px';
			}
			if ( unit == 'px' ) {
				w = val;
			} else if ( unit == 'em' ) {
				w = val*em;
			} else if ( unit == '%' ) {
				w = width*val/100;
			} else {
//				cons.error(offset);
				w = val;
			}
			return w;
		}
		if ( geom.left != null && geom.right != null ) {
			width2 = width - ev(geom.left) - ev(geom.right);
			if ( width2 < 0 ) { width2 = 0; }
			el.style.left = ev(geom.left) + 'px';
			el.style.width = width2+'px';
		}
		if ( geom.top != null && geom.bottom != null ) {
			height2 = height - ev(geom.top) - ev(geom.bottom);
			if ( height2 < 0 ) {height2 = 0;}
			el.style.top = ev(geom.top) + 'px';
			el.style.height = height2+'px';
		}
		for( e = el.firstChild; e != null; e = e.nextSibling ) {
			resize_elem(e,width2,height2);
		}
	}

	// 値の変更。
	dom.change_geom = function(el,geom){
		var k, g, parent;
		if ( (g = el._poto_geom) != null ) {
			for(k in geom) {
				g[k] = geom[k];
			}
//			parent = el.parentNode;
//			resize_elem(el,parent.clientWidth,parent.clientHeight);
		} else {
			for(k in geom) {
				el.style[k] = geom[k];
			}
		}
	}

	// windowの大きさ?
	dom.onresize = function(){
		var e, width, height;
		var i, p, objs;
		width = document.body.clientWidth;
		height = document.body.clientHeight;
		for( e = document.body.firstChild; e != null; e = e.nextSibling ) {
			resize_elem(e,width,height);
		}

		// textareaは親要素と同じサイズにする。
		// 100%指定があるものだけ？
		objs = document.getElementsByTagName('textarea');
		for( i = 0; i < objs.length; i++ ) {
			e = objs[i];
			p = e.parentNode;
			// 4は borderWidth*2
			// とりあえず、めんどうなので固定。
			if ( p.clientWidth >= 4 ) {
				e.style.width = (p.clientWidth-4) + 'px';
			}
			if ( p.clientHeight >= 4 ) {
				e.style.height = (p.clientHeight-4) + 'px';
			}
		}

	};

	(function(){
		var TAGS = [
			'div',
			'table', 'tbody', 'tr', 'td', 'col', 'colgroup',
			'h1', 'h2', 'h3', 'h4', 'h5', 'h6', 'h7',
			'p',
			'ul', 'ol', 'li',
			'hr',
			'span', 'img', 'a', 'sup',
			'form', 'input', 'textarea', 'label', 'select', 'option', 'optgroup',
			'canvas',
		];
		var tag, i;
		for( i = 0; i < TAGS.length; i++ ) {
			tag = TAGS[i];
			dom[tag] = (function (tag){
				var proc;
				if ( ua.msie && (proc = CRAZY_IE[tag]) ) {
					return proc;
				} else {
					return function(){
						var el;
						el = document.createElement(tag);
						setAttr(el,merge_attr(arguments));
						appendElements(el,arguments);
						return el;
					};
				}
			})(tag);
		}
	})();

})();



// てきとう
lib.copy = function(src){
	var dst = {};
	lib.merge(dst,src);
	return(dst);
};

// てきとう
lib.merge = function(dst,src){
	var k, v;
	for( k in src ){
		v = src[k];
		switch(typeof(v)) {
		case 'object':
			dst[k] = lib.copy(v);
			break;
		default:
			dst[k] = v;
			break;
		}
	}
};


})();


// potome.js
(function(){

var ua = poto.ua;
var conf = poto.conf;
var dom = poto.dom;
var cons = poto.cons;
var event = poto.event;
var lib = poto.lib;

var env = poto.env = {};
var option = {}; 
var prog = {};
var stat = {};
var measure = {};

// 
var caliper = {};
var pane = {};
var panel = {};


// mainを消す
var main = {};


// Caliper
(function(){

	// マウス処理用
// 名前...
	var x0, y0, a0, d0;

	function mark_color(r0,g0,b0){
		var opacity;
		opacity = stat.mark_opacity;
		return lib.css_color(r0,g0,b0,opacity);
	}

	function bar_color(r,g,b){
		var op_m, op_b, a;
		op_m = stat.mark_opacity;
		op_b = stat.bar_opacity;
		a = op_m*op_b;
		return lib.css_color(r,g,b,a);
	}

	//

	function scale(x){
		return x * stat.tool_size/960;
	}

	function bar_width(){
		return 40;
	}

	function cmark_width(){
		return bar_width()*3/4;
	}
	function cmark_height(){
		return bar_width()*3/4;
	}
	function marker_size(){
		return bar_width()/2;
	}

	function make_bar1(clp){
		return {
			x: clp.x0,
			y: clp.y0,
			angle: clp.angle+Math.PI/2,
			color: clp.color
		};
	}

	function make_bar2(clp){
		return {
			x: clp.x0 + clp.dist*Math.cos(clp.angle),
			y: clp.y0 + clp.dist*Math.sin(clp.angle),
			angle: clp.angle-Math.PI/2,
			color: clp.color
		};
	}

	// marker
	function draw_marker(ctx,color){
		var w = scale(marker_size());
		var h = scale(marker_size());
		ctx.save();
		ctx.beginPath();
		ctx.moveTo(0,0);
		ctx.lineTo(w,h);
		ctx.lineTo(-w,h);
		ctx.closePath();
		ctx.fillStyle = mark_color(color.r*0.7,color.g*0.7,color.b*0.7);
		ctx.fill();
		ctx.restore();
	}

	// center mark
	function draw_cmark(ctx,color){
		var w = scale(cmark_width());
		var h = scale(cmark_height());
		ctx.save();
		ctx.beginPath();
		ctx.moveTo(0,0);
		ctx.lineTo(w,h);
		ctx.lineTo(-w,h);
		ctx.closePath();
		ctx.fillStyle = mark_color(color.r*0.7,color.g*0.7,color.b*0.7);
		ctx.fill();
		ctx.restore();
	}

	function draw_bmark(ctx,color){
		var x = scale(0);
		var y = scale(bar_width()*1/3);
		var r = scale(4);
		ctx.save();
		ctx.beginPath();
		ctx.arc(x,y,r,0,Math.PI,false);
		ctx.arc(x,y,r,Math.PI,0,false);
		ctx.closePath();
		ctx.fillStyle = mark_color(1,1,1);
		ctx.fill();
		ctx.restore();
	}

	// vmlのstrokeWeightは座標変換の作用を受けないようだが、
	// excanvasはそれに対応していないようだ。
	// ->r3で修正された。
	function lineWidth(w){
		w = scale(w);
//		if ( conf.use_excanvas && G_vmlCanvasManager ) {
//			w *= pane.scale();
//		}
		return w;
	}

	function draw_bar(ctx,color) {
		var wd, ht, r1,g1,b1;

		function make_path(d){
			var C = 0.462;
			ctx.beginPath();
			ctx.moveTo(-wd+d,d);
			ctx.lineTo(wd-d,d);
			ctx.lineTo(wd-d,ht/2-d*C);
			ctx.lineTo(wd-ht/2-d*C,ht-d);
			ctx.lineTo(-wd+ht/2+d*C,ht-d);
			ctx.lineTo(-wd+d,ht/2-d*C);
			ctx.closePath();
		}
		r1 = (color.r+3)/4; g1 = (color.g+3)/4; b1 = (color.b+3)/4;
		wd = scale(stat.bar_size/2);
		ht = scale(bar_width());
		ctx.save();
		if(stat.bar_opacity != 0){
			ctx.fillStyle = bar_color(r1,g1,b1);
			make_path(0);
			ctx.fill();
		}
		make_path(scale(1));
		ctx.strokeStyle = mark_color(r1,g1,b1);
		ctx.lineWidth = lineWidth(3);
		ctx.stroke();
		make_path(0);
		ctx.strokeStyle = mark_color(0,0,0);
		ctx.lineWidth = lineWidth(1);
		ctx.stroke();
		ctx.restore();
	}

	// coinツール
	// ごまかし。
	function draw_coin(x0,y0,angle,dist,n,color){
		var ctx, wd, light, dark;
		var M = 1/4;
		// 0-1座標系だと Operaとexcanvas(vmlかも)がバグる。
		var SCALE = 960;
		light = mark_color(color.r,color.g,color.b);
		dark = mark_color(color.r/2,color.g/2,color.b/2);
		ctx = pane.ctx;
		ctx.save();
		pane.set_ctm(ctx,x0,y0,angle);
		ctx.scale(1/SCALE,1/SCALE);

		function make_path(d){
			ctx.beginPath();
			ctx.arc(
				1/M*dist*SCALE+d*SCALE, 0, 1/M*dist*SCALE,
				Math.PI-Math.acos(1-M),
				Math.PI+Math.acos(1-M),
				false
			);
			ctx.closePath();
		}
		// r3で修正された
//		ctx.lineWidth = lineWidth(
//		 (conf.use_excanvas && G_vmlCanvasManager)? 1: SCALE);
		ctx.lineWidth = lineWidth(SCALE);
		make_path(scale(1));
		ctx.strokeStyle = dark;
		ctx.stroke();
		make_path(scale(0));
		ctx.strokeStyle = light;
		ctx.stroke();
		ctx.restore();
	}

// pane.canvas
	function draw_grid(x0,y0,angle,dist,n,color){
		var ctx, wd, light, dark;
//		ctx = pane.canvas.getContext('2d');
		ctx = pane.ctx;
// 長さ依存...
		wd = scale(60/2);
		light = mark_color(color.r,color.g,color.b);
		dark = mark_color(color.r/2,color.g/2,color.b/2);
		ctx.save();
		pane.set_ctm(ctx,x0,y0,angle);
		ctx.lineWidth = lineWidth(1);
		function sub(color,d){
			var i, x;
			ctx.beginPath();
			for( i = 1; i < n; i++ ) {
				x = i*dist/n;
				ctx.moveTo(x+d,-wd);
				ctx.lineTo(x+d,wd);
			}
			ctx.moveTo(scale(16),d);
			ctx.lineTo(dist-scale(16),d);
			ctx.strokeStyle = color;
			ctx.stroke();
		}
		sub(dark,scale(1));
		sub(light,0);
		ctx.restore();
	}

	function hittest_cmark(bar,e){
		var x1,y1,x2,y2,si,co,x3;
		x1 = e.x - bar.x;
		y1 = e.y - bar.y;
		co = Math.cos(-bar.angle);
		si = Math.sin(-bar.angle);
		y2 = y1*co + x1*si;
		x2 = -y1*si + x1*co;
		if ( y2 < 0 || y2 >= scale(cmark_height()) ) {
			return false;
		}
		x3 = cmark_width()*y2/cmark_height();
		return x2 <= x3 && x2 >= -x3;
	}

	function hittest_bar(bar,e){
		var x1,y1,x2,y2,si,co;
		x1 = e.x - bar.x;
		y1 = e.y - bar.y;
		co = Math.cos(-bar.angle);
		si = Math.sin(-bar.angle);
		y2 = y1*co + x1*si;
		x2 = -y1*si + x1*co;
		w = scale(stat.bar_size/2);
		return x2 >= -w && x2 <= w && y2 >= 0 && y2 < scale(bar_width())? 1: 0;
	}

	//
	function Caliper(i,x,y,angle,color){
		var clp = this;
		clp.idx = i;
		clp.x0 = x;
		clp.y0 = y;
		clp.angle = angle;
		clp.dist = 0;
		clp.color = color;
		clp.status = 1;	/* 0 */
		clp.mode = 0;
	}

	function draw_clp(clp){
		var ctx, ngrid, bar1, bar2, mark_size;
//		ctx = pane.canvas.getContext('2d');
		ctx = pane.ctx;
		bar1 = make_bar1(clp);
		bar2 = make_bar2(clp);
		if ( clp.status == 2 ) {
			ctx.save();
			pane.set_ctm(ctx,bar1.x,bar1.y,bar1.angle);
			draw_bar(ctx,clp.color);
			draw_cmark(ctx,clp.color);
			draw_bmark(ctx,clp.color);
			ctx.restore();
			ctx.save();
			pane.set_ctm(ctx,bar2.x,bar2.y,bar2.angle);
			draw_bar(ctx,clp.color);
			draw_cmark(ctx,clp.color);
			ctx.restore();
			if ( clp.idx == 0 && panel.mdist_mode.value == 'Coin' )  {
				if ( clp.dist > scale(8) ) {
					draw_coin(
						clp.x0,clp.y0,clp.angle,clp.dist,ngrid,
						clp.color
					);
				}
			} else {

				if ( (ngrid = stat.n_grid) > 0  && clp.dist > scale(64) ) {
					draw_grid(
						clp.x0,clp.y0,clp.angle,clp.dist,ngrid,
						clp.color
					);
				}
			}
		} else if ( clp.status == 1 ) {
			if ( clp.dist <= 0 ) return;
			ctx.save();
			pane.set_ctm(ctx,bar1.x,bar1.y,bar1.angle);
			draw_marker(ctx,clp.color);
			draw_bmark(ctx,clp.color);
			ctx.restore();
			ctx.save();
			pane.set_ctm(ctx,bar2.x,bar2.y,bar2.angle);
			draw_marker(ctx,clp.color);
			ctx.restore();
		}
	}

	Caliper.prototype.draw = function(){
		var clp = this;
		var sz, w, v;
		if ( clp.idx == 0 ) {
			if ( panel.mdist_mode.value == 'Caliper')  {
				draw_clp(clp);
			} else if ( panel.mdist_mode.value == 'Coin')  {
				draw_clp(clp);
			} else {
				sz = pane.get_image_size();
// -0.5, 0.5
				if ( !sz ) return;
				w = Math.max(sz.w,sz.h);
				if ( panel.mdist_mode.value == 'full_width' ) {
					v = sz.w/w;
					draw_clp({ x0:-v/2, y0:0, angle:0, dist:v,
						color: clp.color, status: clp.status
					});
				} else {
					// image_height
					v = sz.h/w;
					draw_clp({ x0:0, y0:-v/2, angle:Math.PI/2, dist:v,
						color: clp.color, status: clp.status
					});
				}
			}
		} else {
			draw_clp(clp);
		}
	}

	Caliper.prototype.hit_test = function(e){
		var clp = this;
		var bar1, bar2;
		bar1 = make_bar1(clp);
		bar2 = make_bar2(clp);
		if ( clp.status >= 2 ) {
			if ( hittest_cmark(bar1,e) ) return 'cmark,1';
			if ( hittest_cmark(bar2,e) ) return 'cmark,2';
		}
		if ( clp.status >= 1 ) {
			if ( hittest_bar(bar1,e) ) return 'bar,1';
			if ( hittest_bar(bar2,e) ) return 'bar,2';
		}
		return '';
	}

// 
	Caliper.prototype.hilight = function(e){
		var clp = this;
		return true;
	}

	Caliper.prototype.onmousedown = function(e,mode){
		var clp = this;
		var a;
// ?
		if ( pane.grabbed ) return false;
		clp.mode = mode;

// これもdrag時に処理。
		if ( mode.match(/,1$/) ) {
			a0 = clp.angle + Math.PI;
		} else {
			a0 = clp.angle;
		}
//
		x0 = e.x;
		y0 = e.y;
		d0 = clp.dist;
// ...
		pane.grabbed = clp;
		return false;
	}

	Caliper.prototype.freshdrag = function(e){
		var clp = this;
		clp.x0 = x0 = e.x;
		clp.y0 = y0 = e.y;
		clp.angle = a0 = Math.PI/2;
		clp.dist = d0 = 0;
		clp.status = 2;
		clp.mode = 'cmark,2';
		pane.draw();
		pane.disp_val(clp.dist);
		pane.grabbed = clp;
		return false;
	}

	Caliper.prototype.onmouseup = function(e){
		pane.grabbed = null;
		return false;
	}

	// clpは、コピーの場合がある。
	function drag_cmark(clp,e) {
		var x,y,si,co,x1,y1,x2,y2,r2;
		si = Math.sin(-a0);
		co = Math.cos(-a0);
		x = x0 - clp.x0;
		y = y0 - clp.y0;
		y1 = y*co + x*si;
		x1 = -y*si + x*co;
		x = e.x - clp.x0;
		y = e.y - clp.y0;
		r2 = lib.hypot(x,y);
		y2 = y1;
		x2 = r2 >= Math.abs(y2)? Math.sqrt(r2*r2-y2*y2): 0;
		clp.angle = lib.atan2(y,x) - lib.atan2(y2,x2);
		clp.dist = d0 + Math.abs(x2) - Math.abs(x1);
		if ( clp.dist < 0 ) clp.dist = 0;
	}

	// clpは、コピーの場合がある。
	function drag_bar(clp,e){
		var x,y,si,co,x1,x2;
		si = Math.sin(-a0);
		co = Math.cos(-a0);
		x = x0 - clp.x0;
		y = y0 - clp.y0;
		x1 = -y*si + x*co;
		x = e.x - clp.x0;
		y = e.y - clp.y0;
		x2 = -y*si + x*co;
		clp.dist = d0 + x2 - x1;
		if ( clp.dist < 0 ) clp.dist = 0;
	}

	Caliper.prototype.onmousemove = function(e){
		var clp = this;
		var a, clp2;
		a = clp.mode.split(',');
		if ( a.length < 2 ) return true;
		if ( a[1] == '1' ) {
			clp2 = {
				x0: clp.x0 + clp.dist*Math.cos(clp.angle),
				y0: clp.y0 + clp.dist*Math.sin(clp.angle),
				dist: clp.dist,
				angle: clp.angle + Math.PI
			};
		} else {
			clp2 = clp;
		}
		if ( a[0] == 'cmark' ) {
			drag_cmark(clp2,e);
		} else {
			drag_bar(clp2,e);
		}
		if ( a[1] == '1' ) {
			clp.x0 = clp2.x0 + clp2.dist*Math.cos(clp2.angle);
			clp.y0 = clp2.y0 + clp2.dist*Math.sin(clp2.angle);
			clp.dist = clp2.dist;
			clp.angle = clp2.angle + Math.PI;
		}

		// normalize
		// 0 <= angle < 2pi
		(function(){
			var ip = Math.floor(clp.angle / (2*Math.PI));
			clp.angle -= ip*(2*Math.PI);
		})();

		pane.draw();
		pane.disp_val(clp.dist);
		return false;
	}

	Caliper.prototype.activate = function(){
		var clp = this;
// 
		clp.status = 2;
// draw
	}

	Caliper.prototype.inactivate = function(){
		var clp = this;
		clp.status = 1;
	}

	caliper.create = function(i,x,y,angle,color){
		return new Caliper(i,x,y,angle,color);
	}

})();


// pane
(function(){

	var parts = [];
	pane.selected = '_';

	pane.grabbed = null;


	// 内部座標系
	// 中心を0,0にするかな
	// -0.5 - 0.5

	// 内部座標系からピクセル単位への変換係数
// 
	pane.scale = function(){
		var geom;
		geom = pane.get_image_geom();
		return Math.max(geom.w,geom.h);
	}

	// 内部座標系に変換
	function coord_from_px(po){
		var ox, oy, scale;
		ox = pane.div.clientWidth/2;
		oy = pane.div.clientHeight/2;
		scale = pane.scale();
		return { x:(po.x-ox)/scale, y: (po.y-oy)/scale };
	}

	// ピクセル系に変換(pane.divの左上)
	function coord_to_px(pi){
		var ox, oy, scale;
		ox = pane.div.clientWidth/2;
		oy = pane.div.clientHeight/2;
		scale = pane.scale();
		return{ x:pi.x*scale+ox, y:pi.y*scale+oy };
	}

	// ピクセル座標系に変換するctm
	pane.set_ctm = function(c,x,y,a){
		var x0, y0, scale;
		x0 = pane.div.clientWidth/2;
		y0 = pane.div.clientHeight/2;
		scale = pane.scale();
		c.translate(x0,y0);
		c.scale(scale,scale);
		c.translate(x,y);
		c.rotate(a);
	}

	pane.disp_val = function(v){
		if ( pane.selected == 0
				&& panel.mdist_mode.value == 'Coin' ) {
// 
			v *= 8;
		}
		panel.set(pane.selected,v);
	}

	function clear_canvas(){
		pane.ctx.clearRect(0,0,
			pane.canvas.clientWidth,pane.canvas.clientHeight);
	}

	function draw(){
		var i;
		if ( !measure.ready ) return;
		pane.ctx = pane.canvas.getContext('2d');
		clear_canvas();
		for(i = 0; i < parts.length; i++){
			if ( pane.selected == i ) {
				continue;
			} 
			parts[i].draw();
		}
		if ( pane.selected != '_' ) {
			parts[pane.selected].draw();
		}
	}

	pane.draw = draw;

//
	pane.get_angle = function(i){
		return parts[i].angle;
	}


	//
	pane.select = function(e){
		if ( pane.selected != '_' ) {
			var p = parts[pane.selected];
			if ( pane.selected == 0
					&& panel.mdist_mode.value != 'Caliper'
					&& panel.mdist_mode.value != 'Coin' ) {
				stat.mdist_mode = 'Caliper';
				save_cookie();
				panel.mdist_mode.set('Caliper');
				panel.draw();
			}
			if ( (mode = p.hit_test(e)) ) {
				return p.onmousedown(e,mode);
			}
			return p.freshdrag(e);

		}
		return true;
	}

	pane.hilight = function(e){
		var i;
		for(i = 0; i < parts.length; i++ ) {
			if ( parts[i].hilight(e) ) {
				return;
			}
		}
/*
		pane.canvas.style.cursor = 'crosshair';
*/
	}

	pane.change_parts = function(i){
// nullとか？
		if ( i != pane.selected ) {
			if ( pane.selected != '_' ) {
				parts[pane.selected].inactivate();
			}
			if ( i != '_' ) {
				parts[i].activate();
			}
			pane.selected = i;
			draw();
		}
	}

	function select(e){
		return pane.select(e);
	}

	function hilight(e){
		pane.hilight(e);
	}

// とりあえず
	function trans_event(ev){
		return coord_from_px(event.translate(ev,pane.div));
	}

	function onmousedown(ev){
		var e = trans_event(ev,pane.div);
		if ( pane.grabbed && !pane.grabbed.onmousedown(e)
				|| !select(e) ) {
			event.dontprop(ev);
			return false;
		} else {
			return true;
		}
	}

	function onmouseup(ev){
		if( pane.grabbed
				&& !pane.grabbed.onmouseup(trans_event(ev)) ) {
			event.dontprop(ev);
			return false;
		} else {
			return true;
		}
	}

	function onmousemove(ev){
		if ( pane.grabbed
				&& !pane.grabbed.onmousemove(trans_event(ev)) ) {
			event.dontprop(ev);
			return false;
		} else {
			hilight(trans_event(ev));
			return true;
		}
	}


	// 作業エリアを作る。
	// 画像とcanvasのある方。
	pane.create = function(){

		var mg, w;

		// 画像
		// 速度的な性能は、画像をメモリ上に持っているかどうかによって、
		// 大きく左右される。
		// 特に画像の解像度が高い場合は、メモリ上に持ってないと、
		// 使い物にならないほど遅くなる。
		// canvasは、どのブラウザでも(FF/Safari/Opera)
		// 描画結果をメモリ上に持つようなので、
		// これらのブラウザではcanvasを使った方が早い。
		// IE6の場合、imgはメモリ上に持っているようだが、
		// VMLのimageはメモリ上には持たないようなので、imgを使う。
		mg = conf.img_margin;
		w = 100-2*mg;
		if ( conf.use_img ) {
			pane.img_area = dom.div({
				style:{
					position:'absolute',
					top:mg+'%', left:mg+'%', width:w+'%', height:w+'%'
				}},
				pane.img = dom.img({
					style:{ display:'block', position:'absolute' }}
				)
			);
		} else {
			pane.img_area = dom.div({
				style:{
					position:'absolute',
					top:mg+'%', left:mg+'%', width:w+'%', height:w+'%'
				}},
				pane.img = dom.canvas({
					style:{ position:'absolute', top:0, left:0 }
				})
			);
		}

		// 作業エリア
		pane.div = dom.div({
			style:{
				position:'relative',
				width:'100%', height:'100%'
			}},
			pane.img_area,
			pane.canvas = dom.canvas({
				width:1, height:1,
				style:{
					position:'absolute',
					top:0, left:0,
					cursor:'crosshair'
				}}
			)
		);

		// excanvasを使うとき、静的な要素の場合は何もしなくてよいが、
		// document.createElementでcanvas作った場合は、これが必要。
		// parentNodeを見に行くので、親がいないといけない。
		// 関係ないが、
		// 兄弟にcanvasがいると、消されてしまうようだ(divで囲めばOK)。
		// ->と思ったが、いまいち動きがわからん。
		if ( conf.use_excanvas && G_vmlCanvasManager ) {
			pane.canvas = G_vmlCanvasManager.initElement(pane.canvas);
		}

// excanvas時
// 若干早くなるかと思ったが良くわからん。
//		pane.ctx = pane.canvas.getContext('2d');

		return pane.div;
	}

	var image_path;
	var tmp_img;

	//	オリジナル画像の大きさを取り出す。
	//	直接取り出す方法もあるみたいだ。
	//		FFだと、naturalWidth, naturalHeight。
	//	ただしブラウザ依存でよくわからないので、
	//	ダミーのimgを作ってそこに貼り込み、大きさを取り出している。
// じゃなくて、これは、imgに設定する大きさか
	pane.get_image_geom = function(){
		var w,h,w1,h1,w2,h2, r;
		r = {x:0, y:0, w:0, h:0};
		if ( !tmp_img ) return r;
		w2 = pane.img_area.clientWidth;
		h2 = pane.img_area.clientHeight;
		w1 = tmp_img.clientWidth;
		h1 = tmp_img.clientHeight;
		if ( h1 <= 0 || w1 <= 0 ) {
			r.x = 0;
			r.y = 0;
			r.w = 960;
			r.h = 960;
		} else {
			w = w1*h2/h1;
			h = h2;
			if ( w > w2 ) {
				w = w2;
				h = h1*w2/w1;
			}
// 必要？
			r.x = Math.floor((w2-w)/2);
			r.y = Math.floor((h2-h)/2);
			r.w = w;
			r.h = h;
		}
		return r;
	}

	//　こっちか。
	// 名前。
	// view size
	// image size
	pane.get_image_size = function(){
		var rdmy = { w:960, h:960 };
		var r = {};
		if ( !tmp_img ) return rdmy;
		r.w = tmp_img.clientWidth;
		r.h = tmp_img.clientHeight;
		if ( isNaN(r.w) || isNaN(r.h) ) return rdmy;
		if ( r.w == 0 || r.h == 0 ) return rdmy;
		return r;
	}

// 
	var tmp_img_ready = 0;


	// 画像領域のリサイズされた時の処理
	function img_onresize(){
		if ( conf.use_img ) {
			// imgを使う(ieの場合)。
			var geom = pane.get_image_geom();
			pane.img.style.top = geom.y+'px';
			pane.img.style.left = geom.x+'px';
			pane.img.style.width = geom.w+'px';
			pane.img.style.height = geom.h+'px';
		} else {
			// canvasを使う(ie以外)。
			var ctx, geom;
			geom = pane.get_image_geom();
			pane.img.width = pane.img_area.clientWidth;
			pane.img.height = pane.img_area.clientHeight;
			if ( tmp_img_ready ) {
				ctx = pane.img.getContext('2d');
				ctx.save();
				ctx.drawImage(tmp_img,geom.x,geom.y,geom.w,geom.h);
				ctx.restore();
			}
		}
	}

	// img.onload時
	function img_replace(){

		tmp_img_ready = 1;
		img_onresize();
		
		if ( conf.use_img ) {
			pane.img.src = image_path;
		}

		pane.draw();

		// 全幅とかだけで良い…
		panel.draw();
	}

	pane.onload = function(){
		var a, n, i;	

// mark width
		a = Math.PI/2;

// tool_color.length
		n = conf.n_tool;
		if ( n > conf.tool_color.length ) {
			n = conf.tool_color.length;
		}
		// n >= 1 !
		for( i = 0; i < n; i++ ) {
			parts[i] = caliper.create(i,
					-0.5+(2*i+1)/(2*n), 0,a,
					conf.tool_color[i]
			);
		}

//

		// テンポラリ。ファイルが存在するかとか、大きさとか。
		tmp_img = dom.img({
			style:{
				display:'block',
				position:'absolute',
				top:0,
				left:0,
				visibility:'hidden'

			}
		});

		// div入れないと、Safariで、スクロールされてしまう場合がある。
		document.body.appendChild(
			dom.div({
				style:{
					position:'relative',
					visibility:'hidden',
					width:'1px',
					height:'1px',
					overflow:'hidden'
				}},
				tmp_img
			)
		);

		event.addEvent(pane.div,'mousedown',onmousedown);
		event.addEvent(document,'mousemove',onmousemove);
		event.addEvent(document,'mouseup',onmouseup);

	}

	// 
	pane.onresize = function(){

		// 少なくとも必要なサイズより大きいサイズを指定する必要がある。
		// 変更回数を減らすような処理を入れても速度的には変わらなかった。
		pane.canvas.width = pane.div.clientWidth;
		pane.canvas.height = pane.div.clientHeight;

		img_onresize();

		pane.draw();
	}

	pane.set_image = function(file){
		image_path = file;
		tmp_img_ready = 0;
		tmp_img.onload = function(){
			tmp_img.onload = null;
			img_replace();
		}
		tmp_img.src = file;
	}

})();


//
// どこにおこう?
function save_cookie(){
	var t, i, key;
	var options = [
		'n_grid', 'bar_size', 'tool_size',
		'mark_opacity', 'bar_opacity',
		'font_size', 'console',
		'known_dist', 'mdist_mode', 
		'prog_0', 'prog_1', 'prog_2', 'prog_3', 'prog_4', 'prog_5',
	];
	t = {};
	for( i = 0; i < options.length; i++ ) {
		key = options[i];
		t[key] = stat[key];
	}
	lib.cookie.save(conf.cookie_name,t);
};


// Panel
(function(){


// local
var menu = {};



// panel(右側)
(function(){

	panel.text = [];
	panel.radio = [];
	panel.val = [];


	panel.prec = 0;
	panel.unit = '';
	panel.scale = 1;


	panel.draw = function(){
		var i, t, v, a, scale, sz, w;
		if ( !main.ready ) return;
		sz = pane.get_image_size();
		if ( !sz )  return;
		w = Math.max(sz.w,sz.h);
		if ( panel.mdist_mode.value == 'Caliper' ) {
			v = panel.val[0];
		} else if ( panel.mdist_mode.value == 'Coin' ) {
			v = panel.val[0];
		} else if ( panel.mdist_mode.value == 'full_width' ) {
			v = sz.w/w;
		} else if ( panel.mdist_mode.value == 'full_height' ) {
			v = sz.h/w;
		}
		if ( !isNaN(v) && v > 0 && !isNaN(panel.ref_size) ) {
			panel.set_text(0,lib.prtf(v*w,0) + 'px');
			scale = panel.ref_size / v;
			for( i = 1; i < 6; i++ ) {
				v = panel.val[i]*scale;
				a = pane.get_angle(i);

				poto.env.D[i] = v;
				poto.env.A[i] = a;
				poto.env['d'+i] = v;
				poto.env['a'+i] = a;

				t = isNaN(v)? '': lib.prtf(v,panel.prec) + panel.unit;
				panel.set_text(i,t);
			}

			prog.run();
		}
	}

	panel.set = function(i,v){
		panel.val[i] = v;
		panel.draw();
	}


	/*
		real size 

		panel.unit			単位
		panel.prec			小数点以下表示桁数
		panel.real_size 	

		自動的に決める。有効桁数３桁。
		ただし、指定されたものより短くはしない。
	*/
	var N = 3;
	function set_kdist(val){
		var a, s, v, u, m, n;
		a = val.match(/^([+-\.0-9]*)([^+-\.0-9].*)$/);
		if ( !a ) {
			s = val;
			panel.unit = '';
		} else {
			s = a[1];
			panel.unit = a[2];
		}
		if ( s == '' ) {
			v = 1;
		} else {
			v = parseFloat(s);
		}
		panel.ref_size = v;
		u = Math.abs(v);
		m = N - 1 - Math.floor(Math.log(u)/Math.log(10));
		if ( m < 0 ) { m = 0; }
		if ( (a = s.match(/^(.*)\.([^\.]*)$/)) ) {
			n = a[2].length;
		} else {
			n = 0;
		}
		if ( m < n ) { m = n; }
		panel.prec = m;
	}

	option.kdist_menu = {};
	option.kdist_menu.onchange = function(){
		var i, sel, val;
		sel = option.kdist_menu.obj;
		if ( (i = sel.selectedIndex) != null ) {
			val = sel.options[i].value;
			if ( val != '' ) {
				sel.selectedIndex = 0;
				panel.kdist.obj.value = val;
				stat.known_dist = val;
				save_cookie();
				set_kdist(val);
				panel.draw();
			}
		}
	}

// known_dist
	panel.kdist = {};
	panel.kdist.onchange = function(){
		stat.known_dist = panel.kdist.obj.value;
		save_cookie();
		set_kdist(panel.kdist.obj.value);
		panel.draw();
	}


	panel.mdist_mode = {};
	panel.mdist_mode.onchange = function(){
		var i, sel, val, w;
		sel = panel.mdist_mode.obj;
		if ( (i = sel.selectedIndex) != null ) {
			val = sel.options[i].value;
			if ( val != '' ) {
				stat.mdist_mode = val;
				save_cookie();
				panel.mdist_mode.value = val;
				panel.draw();
				pane.draw();
			}
		}
	}

	panel.mdist_mode.set = function(val){
		menu.set(panel.mdist_mode.obj,val);
		panel.mdist_mode.value = val;
	}
	panel.mdist_mode.get = function(){
		return panel.mdist_mode.value;
	}


	panel.create = function(){
		var i, elem, icon, c, div;

		function f(v){
			return(v+2)/3*(0.85);
		}

		function hr(){
			return dom.div({
				style:{
					height:0, borderTop:'groove 2px #CCC'
				}}
			);
		}

		function radio_button(i,color,text){
			var ht = 2.5;
			return dom.td({
				style:{
					verticalAlign:'middle',
					borderTop:'groove 2px #CCC'
				}},
				dom.label({'for':'r'+i,
					style:{
						display:'block',
						overflow:'hidden',
						width:'100%',
						height:'1em',
						lineHeight:'1em',
						paddingTop:((ht-1)/2) + 'em',
						paddingBottom:((ht-1)/2) + 'em',
						textAlign:'center',
						verticalAlign:'middle',
						backgroundColor:color,
						color:'#333'
					}},
					panel.radio[i] = (function(){
						var idx = i;
						var obj;
						obj = dom.input({
							type:'radio',
							name:'tool',
							id:'r'+i,
							value:i,
							onclick:function(){
								if(obj.checked) {
									pane.change_parts(idx);
								}
							}
						});
						return obj;
					})(),
					text
				)
			);
		}

		function text(t){
			return dom.div({
				style:{
					overflow:'hidden',
					width:'100%'
				}},
				dom.div({
					style:{
						paddingLeft:"0.5em",
						height:'1.5em',
						width:'20em',
						fontSize:'0.8em'
					}},
					t
				)
			);
		}

// はいれつを返せれば良い。

		i = '_';
		var tbody;

		div = dom.table({
			style:{
				width:'100%',
				tableLayout:'fixed',
				borderCollapse:'collapse'
			}},
			dom.colgroup(
				dom.col({width:'15%'}),
				dom.col({width:'85%'})
			),
			tbody = dom.tbody(
			)
		);

		var c = {r:0.2,g:0.2,b:0.2};

		// textboxについては、上から大きさを指定することができないようだ。
		// (left & rigthでの指定)
		// でwidthで指定しているのだが、100%にするとだいぶ広がるので、
		// 右余白を多めにしてある…。
		// IEで、width:100%にするとtdのpaddingが無視されるので、divを入れる。
		tbody.appendChild(
			dom.tr(
				dom.td({
					style:{
						borderTop:'groove 2px #CCC'
					}}
				),
				dom.td({
					style:{
						verticalAlign:'middle',
						overflow:'visible',
						borderTop:'groove 2px #CCC'
					}},
					dom.div({
						style:{paddingLeft:'0.5em',
							paddingRight:'0.75em',
							paddingTop:0,
							paddingBottom:'0.25em'
						}},
						text("Known Distance"),
						panel.kdist.obj = dom.input({type:'text',
							onchange: panel.kdist.onchange,
							oninput: panel.kdist.onchange,
							style:{
								width:'100%',
								fontFamily:'monospace',
								fontSize:'1.3em',
								textAlign:'right'
							}
						}),
						(function(){
							var obj, i, tbl, e, a, v;
							option.kdist_menu.obj = obj = dom.select({
								onchange: option.kdist_menu.onchange,
								style:{
									width:'100%',
									backgroundColor:'#EEE',
									borderColor:'#999',
									fontSize:'1em'
								}}
							);
							obj.appendChild(
								dom.option({value:''},'(preset values)')
							);
							tbl = conf.kdist;
							for( i = 0; i < tbl.length; i++ ) {
								e = tbl[i];
								if ( e == null ) { continue; }
								if ( (a = e.match(/:\s*([^:]+)$/)) ) {
									v = a[1];
								} else {
									v = e;
								}
								obj.appendChild(
									dom.option({value: v},e)
								);
							}
							return obj;
						})()
					)
				)
			)
		);

		tbody.appendChild(
			dom.tr(
				radio_button('_',
					lib.css_color(f(c.r),f(c.g),f(c.b),1),''),
				dom.td({
					style:{
						verticalAlign:'middle',
						paddingLeft:'0.5em',
						paddingRight:'0.75em',
						paddingTop:0,
						paddingBottom:'0.25em',
						borderTop:'groove 2px #CCC'
					}},
					text('Unselect')
				)
			)
		);

		// red
		i = 0;
		c = conf.tool_color[i];
		tbody.appendChild(
			dom.tr(
				radio_button(i,
					lib.css_color(f(c.r),f(c.g),f(c.b),1),
					i
				),
				dom.td({
					style:{
						verticalAlign:'middle',
						borderTop:'groove 2px #CCC'
					}},
					dom.div({
						style:{
							paddingLeft:'0.5em',
							paddingRight:'0.75em',
							paddingTop:0,
							paddingBottom:'0.25em'
						}},
						text("Measured Distance"),
						panel.text[i] = (function(){
							var obj = dom.input({type:'text',
								readOnly:true,
								onclick:function(){ obj.select(); },
								style:{
									display:'block',
									width:'100%',
									fontSize:'1.3em',
									padding:0,
									backgroundColor:'#DDD',
									border:'inset 2px #DDD',
									fontFamily:'monospace',
									textAlign:'right'
								}
							});
							return obj;
						})(),
						panel.mdist_mode.obj = dom.select({
							onchange: panel.mdist_mode.onchange,
							style:{
								display:'block',
								width:'100%',
								backgroundColor:'#EEE',
								borderColor:'#999',
								fontSize:'1em'
							}},
							dom.option({value: 'Caliper'}, "Caliper"),
							dom.option({value: 'Coin'}, "Coin"),
							dom.option({value: 'full_width'}, "full width"),
							dom.option({value: 'full_height'}, "full height")
						)
					)
				)
			)
		);

		for( i = 1; i < conf.n_tool; i++ ) {
			c = conf.tool_color[i];
			tbody.appendChild(
				dom.tr(
					radio_button(i,
						lib.css_color(f(c.r),f(c.g),f(c.b),1),
						i
					),
					dom.td({
						style:{
							verticalAlign:'middle',
							borderTop:'groove 2px #CCC'
						}},
						dom.div({
							style:{
								paddingLeft:'0.5em',
								paddingRight:'0.75em',
								paddingTop:0,
								paddingBottom:'0.25em'
							}},
							panel.text[i] = (function(){
								var obj = dom.input({type:'text',
									readOnly:true,
									onclick:function(){ obj.select(); },
									style:{
										display:'block',
										fontSize:'1.3em',
										padding:0,
										width:'100%',
										backgroundColor:'#DDD',
										border:'inset 2px #DDD',
										fontFamily:'monospace',
										textAlign:'right'
									}
								});
								return obj;
							})()
						)
					)
				)
			);
		}

		for( i = 0; i < conf.n_prog; i++ ) {
			tbody.appendChild(
				dom.tr(
					dom.td(),
					dom.td({
						style:{
							verticalAlign:'middle',
							borderTop:'groove 2px #CCC'
						}},
						dom.div({
							style:{
								paddingLeft:'0.5em',
								paddingRight:'0.75em',
								paddingTop:0,
								paddingBottom:'0.25em'
							}},
							prog.src[i] = (function(){
								var idx = i;
								var obj = dom.input({type:'text',
/*
									oninput:function(){
										prog.compile(idx);
									},
*/
									onchange:function(){
										stat['prog_'+idx] = obj.value;
										save_cookie();
										prog.compile(idx);
									},
									style:{
										display:'block',
										fontSize:'1.3em',
										padding:0,
										width:'100%',
										fontFamily:'monospace'
									}
								});
								return obj;
							})()
						),
						dom.div({
							style:{
								paddingLeft:'0.5em',
								paddingRight:'0.75em',
								paddingTop:0,
								paddingBottom:'0.25em'
							}},
							prog.output[i] = (function(){
								var obj = dom.input({type:'text',
									readOnly:true,
									onclick:function(){ obj.select(); },
									style:{
										display:'block',
										fontSize:'1.3em',
										padding:0,
										width:'100%',
										backgroundColor:'#DDD',
										border:'inset 2px #DDD',
										fontFamily:'monospace',
										textAlign:'right'
									}
								});
								return obj;
							})()
						)
					)
				)
			);
		}
		return div;
	}


	panel.set_text = function(i,v){
		panel.text[i].value = v;
	}

	panel.onload = function(){
		var v;

		v = stat.known_dist;
		panel.kdist.obj.value = v;
		set_kdist(v);

		panel.mdist_mode.set(stat.mdist_mode);

		v = stat.ctool;
		pane.change_parts(v);
		panel.radio[v].checked = 1;

		measure.set_image(stat.src);
	};

})();

(function(){

	// lib?

	menu.set = function(sel,val){
		var i;
		for( i = 0; i < sel.options.length; i++ ) {
			if ( sel.options[i].value == val ) {
				sel.selectedIndex = i;
				return;
			}
		}
		sel.selectedIndex = -1;
	}

})();

// option
(function(){

	var options = [
		'n_grid', 'bar_size', 'tool_size',
		'mark_opacity', 'bar_opacity', 'font_size', 'console'
	];

	function create_menu(name,onchange){
		var opt;

		option[name] = opt = {};

		opt.onchange = function(){
			var i, sel, val;
			sel = opt.obj;
			if ( (i = sel.selectedIndex) != null ) {
				val = parseFloat(sel.options[i].value);
				stat[name] = val;
				save_cookie();
				if ( onchange ) {
					onchange(val);
				} else {
					pane.draw();
				}
			}
		}

		opt.set = function(val){
			if ( opt.obj ) {
				menu.set(opt.obj,val);
			}
			stat[name] = val;
			if ( onchange ) {
				onchange(val);
			}
		}

		opt.create = function(){
			var td, sel, i, e, group, parent, list;
			td = dom.td(
				opt.obj = sel = dom.select({
					onchange: opt.onchange,
					style:{
						display:'block',
						width:'100%',
backgroundColor:'#EEE',
borderColor:'#999',
						fontSize:'1em'
					}
				})
			);
			list = conf[name];
			parent = sel;
			for( i = 0; i < list.length; i++ ) {
				e = list[i];
				if ( !e ) continue;
				if ( e.group ) {
					group = dom.optgroup({label:e.group});
					sel.appendChild(group);
					parent = group;
				} else {
					parent.appendChild(dom.option(
						{value:e.value}, e.text
					));
				}
			}
			return td;
		}
	}

	option.dummy = {};
	option.dummy.create = function(){
		return dom.td();
	};

	create_menu('n_grid');
	create_menu('bar_size');
	create_menu('tool_size');
	create_menu('mark_opacity');
	create_menu('bar_opacity');
	create_menu('console', function(val){ main.resize_console(val); });
	create_menu('font_size',
		function(val){
			document.body.style.fontSize = (val*100) + '%';
				// main.onresize();
				// IEとOperaは、すぐに呼んでもダメみたいだ。
				// 以下のようにするとIEの方は救われる。
				setTimeout(main.onresize,0);
		}
	);


	// onloa/
	option.onload = function(){
		var tmp, i, key;

		for( i = 0; i < options.length; i++ ) {
			key = options[i];
			option[key].set(stat[key]);
		}

		// 賞味期限の更新。
// main で。
		save_cookie();

	}

})();


// measure
(function(){

	measure.create = function(){

		var upart_height = 3;
		var lpart_height = 2;

		function upper_part(){

			var w_logo = 15;
			var w_dropbox = 10;

			return dom.table({
				style:{
					position:'absolute',
					top:0, left:0,
					width:'100%',
					height:upart_height+'em',
					tableLayout:'fixed',
					borderCollapse:'collapse'
				}},
				dom.colgroup(
					dom.col({width:w_logo+'%'}),
					dom.col({width:(100-w_logo-w_dropbox)+'%'}),
					dom.col({width:w_dropbox+'%'})
				),
				dom.tbody(
					dom.tr(
						dom.td({
								style:{
									paddingLeft:'0.5em',
									paddingRight:'0.5em',
									overflow:'hidden'
								}
							},
							dom.div({
								style:{
									width:'12em'
								}},
								dom.a({href:'index.html'},
									dom.span({
										style:{
											fontSize:'1.2em',
											fontWeight:'bold',
											lineHeight:'1.2em'
										}},
										'Potome '
									),
									dom.span({
										style:{
											fontSize:'0.8em'
										}},
										poto.version
									)
								)
							),
							dom.div({
								style:{
									width:'20em',
									fontSize:'0.7em',
									lineHeight:'1.2em'
								}},
								dom.a({href:'http://tamagaro.net/'},
									'(C) 2010 Hepota'
								)
							)
						),
						dom.td(
							dom.div({
								style:{
									paddingRight:'1em'
								}},
								(function(){
									var ta = dom.input({type:'text',name:'path',
	// 画像をdropしたとき、パス名が貼り込まれるが、イベントが来ない
										onchange:function(){
										cons.debug('onchange');
											measure.set_image(ta.value);
										},
	/*
										oninput:function(){
											measure.set_image(ta.value);
										},
									*/
										style:{
											display:'block',
											fontSize:'1em',
											width:'100%',
	//										height:'2em'
											padding:'0.25em'
										}}
									);

	// panel
	panel.path = {};
	panel.path.obj = ta;
									return ta;
								})()
							)
						),
						dom.td(
							dom.div({
								style:{
									paddingLeft:'0.25em',
									paddingTop:'0.25em',
									paddingBottom:'0.25em',
									paddingRight:'1em'
								}},
								dom.div({
									style:{
										border:'inset 3px #FCC',
										width:'100%',
										height:'2em',
										overflow:'hidden',
										backgroundImage:'url("drop_here.gif")'
									}},
									panel.drop_box = dom.input({
										type:'text',name:'drop_box',
										style:{
											fontSize:'1em',
											width:'100%', height:'3em',
											backgroundColor:'transparent',
											margin:0,
											padding:0,
											border:'none',
											color:'#C00'
										}}
									)
								)
							)
						)
					)
				)
			);
		}

		function lower_part(){
			var nopt, w, h;
			nopt = lib.count(conf.option);
			if ( nopt <= 0 ) {
				conf.option = [ 'dummy' ];
				nopt = 1;
			}
			w = 95/(nopt);
			h = lpart_height;
			// divを入れないとIEでおかしくなる。
			return measure.opt_div = dom.div({
				style:{
					position:'absolute',
					left:0, bottom:0,
					width:'100%',
					height:h+'em'
				}},
				dom.table({
					style:{
						position:'absolute',
						left:0,
						bottom:0,
						width:'100%',
						height:h+'em',
						tableLayout:'fixed',
						borderCollapse:'collapse'
					}},
					dom.colgroup(
						lib.repeat(
							function(){return dom.col({width:w+'%'});},
							nopt
						),
						dom.col({width:'5%'})
					),
					dom.tbody(
						dom.tr(
							lib.map(
								function(name){
									return name? option[name].create(): null
								},
								conf.option
							)
							,dom.td()
						)
					)
				)
			);
		}

		main.div.appendChild(
			measure.div = dom.div({
				style:{
//					display:'none',
					position:'absolute',
					top:0, bottom:0,
					left:0, right:0
//					width:'100%',
//					height:'100%'
				}},
				upper_part(),
				measure.lower_div = dom.div({
					id:'measure_lower_div',
					style:{
						position:'absolute', overflow:'hidden',
						top:upart_height+'em',
						bottom:lpart_height+'em',
						left:0, right:0
					}},
					pane.div = dom.div({
						id:'pane_div',
						style:{
							position:'absolute', overflow:'hidden',
							left:0, right:conf.side_panel_width+'%',
							border:'inset 2px #EEE', backgroundColor:'#DDD',
							top:0, bottom:0
						}},
						pane.create()
					),
					panel.div = dom.div({
						id:'panel_div',
						style:{
							position:'absolute', overflow:'hidden',
							marginLeft:'4px',
							marginRight:'4px',
							top:0, bottom:0,
							left:(100-conf.side_panel_width)+'%',
							right:0
						}},
						panel.create()
					)
				),
				lower_part()
			)
		);

	}

	measure.onload = function(){
		function ondragover(ev){
			event.dontprop(ev);
		}
		function ondragenter(ev){
			event.dontprop(ev);
		}

		// 
		function get_drop_data(ev){
			var s, a, path;
			var types;
			if ( !ev && !(ev = window.event) ) {
				return null;
			}
// engine
// option

			// html5で標準化されるので、調べておくべし。
			if ( ua.msie ) {
				types = [ 'URL', 'Text' ];
			} else {

				types = [ 'text/uri-list', 'text/plain' ];
			}
			for( i = 0; i < types.length; i++ ) {
				if ( (s = ev.dataTransfer.getData(types[i])) ) {
					break;
				}
			}
			if ( !s ) {
				if ( ev.dataTransfer.types ) {
					cons.debug(ev.dataTransfer.types.join('\n'));
				}
				return null;
			}
			a = s.split(/\n/);
			if ( a ) {
				path = a[0];
			} else {
				path = a;
			}
			return path;
		}

		// とりあえず、うちのSafariは、これで動いているようだ。
		function ondrop(ev){
			path = get_drop_data(ev);
			if ( path ) {
				measure.set_image(path);
//				pane.draw();
				event.dontprop(ev);
				return false;
			} else {
				return true;
			}
		}


		// デフォルト値
		stat = lib.copy(conf.dflt);

		// クッキー
		lib.merge(stat,lib.cookie.load(conf.cookie_name));

		// クエリーストリングでの指定
		lib.merge(stat,lib.get_query_info());

		pane.onload();
		option.onload();

		panel.onload();

		prog.onload();

		event.addEvent(pane.div, 'dragover', ondragover);
		event.addEvent(pane.div, 'dragenter', ondragenter);
		event.addEvent(pane.div, 'drop', ondrop);

		// Safariは、テキストボックスに落とせる場所が狭いので、
		// こっちを有効にしておく。
		event.addEvent(panel.drop_box, 'dragover', ondragover);
		event.addEvent(panel.drop_box, 'dragenter', ondragenter);
		event.addEvent(panel.drop_box, 'drop', ondrop);


		// drop box
		setInterval(
			function(){
				var path;
				if ( (path = panel.drop_box.value) ) {
					panel.drop_box.value = '';
						measure.set_image(path);
				}
			}
			,100
		);

	}

	measure.set_image = function(path){
		path = path.replace(/\\/g,'/');
		if ( path.match(/^\w:/) ) {
			path = 'file:///' + path;
		} else if ( path.match(/^\//) ) {
			path = 'file://' + path;
		}
		panel.path.obj.value = path;
		pane.set_image(path);
	}

	measure.show = function(){
		measure.div.style.display = 'block';
//
	}

	measure.onresize = function(){
		pane.onresize();
	}


})();

})();


// prog
(function(){

// やっぱりパネル。
// env だけ分離しておくか....

	prog.src = [];
	prog.func = [];
	prog.output = [];

	//

	env.E = Math.E;
	env.PI = Math.PI;
	env.sin = Math.sin;
	env.cos = Math.cos;
	env.tan = Math.tan;

	env.acos = Math.acos;
	env.asin = Math.asin;
	env.atan = Math.atan;
	env.atan2 = Math.atan2;
	env.sqrt = Math.sqrt;
	env.pow = Math.pow;
	env.exp = Math.exp;
	env.log = Math.log;
	env.max = Math.max;
	env.min = Math.min;
	env.floor = Math.floor;
	env.ceil = Math.ceil;
	env.round = Math.round;
	env.random = Math.random;

	// 固定小数点表示関数
	env.prtf = lib.prtf;
	env.f = function(x){ return lib.prtf(x,env.prec); };
	env.f0 = function(x){ return lib.prtf(x,0); };
	env.f1 = function(x){ return lib.prtf(x,1); };
	env.f2 = function(x){ return lib.prtf(x,2); };
	env.f3 = function(x){ return lib.prtf(x,3); };
	env.f4 = function(x){ return lib.prtf(x,4); };
	env.f5 = function(x){ return lib.prtf(x,5); };

// 正規化
	env.deg = function(a){
		return a/Math.PI*180;
	}

	env.D = [];
	env.A = [];
	env.v = {};

	// 角度の差 radian
	// 絶対値? 内角?
	env.angle = function(a1,a2){
		var a = a1-a2+Math.PI;
		var m = Math.floor(a/(2*Math.PI));
		a = Math.abs(a - m*(2*Math.PI) - Math.PI);
		return a;
	}



	prog.compile = function(i){
		var e, err, a;
		err = null;
//		var s = prog.src[i].value;
		var s = stat['prog_'+i];
		if ( s == null ) {
			return;
		}

		var src = "with(poto.env){return("
			+ s + ");}";
		try{
			prog.func[i] = new Function(src);
			
		} catch(e){
			err = e.toString();
		}
		if ( err ) {
			(function(){
				var msg = err;
				prog.func[i] = function(){ return msg; };
			})();
			prog.output[i].style.color = '#900';
			cons.error(err);
		} else {
			prog.output[i].style.color = '';
		}
		panel.draw();
	}

	prog.run = function(){
		var i, f, s, e;

		//
		env.unit = panel.unit;
		env.prec = panel.prec;

		for( i = 0; i < conf.n_prog; i++ ) {
			f = prog.func[i];
			if ( f ) {
				try{
					s = f();
				} catch(e){
					s = e.toString();
				}
// 実行時エラー
				if ( s == null ) s = '';
				prog.output[i].value = s;
			}
		}
	}

	prog.onload = function(){
		var i;
		for( i = 0; i < conf.n_prog; i++ ) {
//			prog.src[i].value = conf.prog[i];
			prog.src[i].value = stat['prog_'+i];
			prog.compile(i);
		}
	}

})();




// confのデフォルト
(function(){

	// なにか入れておくか？
	conf.n_grid=[];
	conf.bar_size=[];
	conf.opacity=[];
	conf.bar_opacity=[];
	conf.kdist=[];
// console

	conf.img_margin = 5; // %

	conf.n_prog = 0;
	conf.prog = [];


//!
//画像の表示に imgを使うかcanvasを使うか。
// 
	// 後ろの画像として、canvasを使わずにimgを使う。
	// メモリに持ち上げてくれるかどうか。
	// IE6では、VMLの画像はメモリに持ち上げてくれない。
	conf.use_img = ua.msie;

//
	conf.use_excanvas = ua.msie;

	conf.side_panel_width = 25; // %

})();


// main?
(function(){

	main.ready = 0;

	// conf
	var tbar_height = 0;

	option.cons_size = 4;

	var root_div;
	var cons_div;
	var tbar_div;

	// 行数
	main.cons_height = 0;

	main.resize_console = function(n){
		// これよく引っかかる...
		n = parseInt(n);
		if ( n == main.cons_height ) {
			return;
		}
		if ( n == 0 ) {
			cons_div.style.display = 'none';
		} else {
			if ( main.cons_height == 0 ) {
				cons_div.style.display = 'block';
			}
		}
		main.cons_height = n;
		cons_div.style.height = n+'em';
		dom.change_geom(main.div,{bottom:n+'em'});
		main.onresize();
	};

	function onload(){
		// main.create();

		if ( ua.unsupport ) {
			document.body.innerHTML =
				'<div class="error">Unsupported Browser</div>';
			return;
		}

		document.body.appendChild(
			root_div = dom.div({
				style:{
					position:'absolute',
					top:0, bottom:0,
					left:0, right:0,
					fontSize:'1em',
					lineHeight:'1em',
					backgroundColor:'#BBB'
				}},
				main.div = dom.div({
					id:'main_div',
					style:{
						position:'absolute',
						left:0, right:0,
						top:0,
						bottom:main.cons_height+'em'
					}}
				),
				cons_div = dom.div({
					style:{
						position:'absolute', display:'none',
						left:0, bottom:0,
						width:'100%', height:main.cons_height+'em'
					}},
					cons.create()
				)
			)
		);


// IE?
// これが必要だったような...
		document.body.style.fontSize = '100%';

		// いったん、8行に設定。
		main.resize_console(8);
		measure.create();

		measure.onload();

		main.resize_console(stat.console);

		main.ready = 1;
		measure.ready = 1;

// タイミング
		measure.show();

		main.onresize();

		//
		cons.info('Potome ', poto.version);
		cons.debug(navigator.userAgent.toLowerCase());
		cons.debug('msie: ',ua.msie);
		cons.debug('safari: ',ua.safari);
		cons.debug('firefox: ',ua.firefox);
		cons.debug('opera: ',ua.opera);

	}

	main.onresize = function(){
		if ( !main.ready ) return;
		dom.onresize(root_div);
		measure.onresize();
	}

	event.addEvent(window, 'load', onload);

	if ( !ua.unsupport ) {
		event.addEvent(window, 'resize', main.onresize);
	}

})();

})();
